<?php
/*
Plugin Name: wp-lessons-3
Author: Pavel
Author URI: http://plance.in.ua
*/
defined('ABSPATH') or die('No script kiddies please!');

if(is_admin() == TRUE)
{
	register_activation_hook(__FILE__, function(){
		global $user_ID;
		
		wp_insert_post(array(
			'post_type'			=> 'page',
			'post_title'		=> 'Солнце',
			'post_content'		=> file_get_contents(__DIR__.'/page.html'),
			'comment_status'	=> 'closed',
			'post_status'		=> 'private',
			'ping_status'		=> 'closed',
			'post_author'		=> $user_ID,
			'post_name'			=> 'module-name-page-sun',
			'post_password'		=> time(),
		));
	});
}
else if((strpos($_SERVER["REQUEST_URI"], '/some-module-page') !== false))
{
	add_filter('the_posts', function($_posts = '', $_query = '')
	{
		global $wp_query;
		
		if(empty($_posts) == false)
		{
			return $_posts;
		}
		
		$Page = get_page_by_path('module-name-page-sun');
		if(is_object($Page) == false)
		{
			wp_die('Page not found');
		}
		
		$posts[] =
			(object) array(
				'ID'                    => '9999999',
				'post_author'           => '1',
				'post_date'             => '2001-01-01 01:01:01',
				'post_date_gmt'         => '2001-01-01 01:01:01',
				'post_title'            => $Page -> post_title,
				'post_content'          => $Page -> post_content,
				'post_excerpt'          => '',
				'post_status'           => 'publish',
				'comment_status'        => 'closed',
				'ping_status'           => 'closed',
				'post_password'         => '',
				'to_ping'               => '',
				'pinged'                => '',
				'post_modified'         => '2001-01-01 01:01:01',
				'post_modified_gmt'     => '2001-01-01 01:01:01',
				'post_content_filtered' => '',
				'post_parent'           => '0',
				'menu_order'            => '0',
				'post_type'             => 'page',
				'post_mime_type'        => '',
				'post_category'         => '0',
				'comment_count'         => '0',
				'filter'                => 'raw',
				'guid'                  => get_bloginfo('url').'/?page_id=9999999',
				'post_name'             => get_bloginfo('url').'/?page_id=9999999',
				'ancestors'             => array()
			);

			$wp_query -> is_page   = true;
			$wp_query -> is_single = false;
			$wp_query -> is_home   = false;
			$wp_query -> comments  = false;
			unset($wp_query -> query['error']);
			$wp_query -> query_vars['error'] = '';
			$wp_query -> is_404	   = false;

			remove_filter('the_content', 'wpautop');

		return $posts;
	}, 10, 2);
}